-- Banco de pruebas del detector de nmero par entradas '1'  
-- fichero: bp_detectorPar.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity bp_detectorPar is
end entity bp_detectorPar;

architecture bp_arch of bp_detectorPar is
    
   component detectorPar is
      port ( par  :  out  std_logic;
             a    :  in   std_logic_vector(2 downto 0) );
   end component detectorPar;

   signal test_in  : std_logic_vector(2 downto 0);
   signal test_out : std_logic;
begin
   -- Instancia del circuito que va a ser testeado
   UUT : detectorPar port map ( par => test_out, a => test_in );
   
   -- Vectores de test
   vect_test: process
   begin
       test_in <= "000";   wait for 200 ns;
       test_in <= "001";   wait for 200 ns;
       test_in <= "010";   wait for 200 ns;
       test_in <= "011";   wait for 200 ns;
       test_in <= "100";   wait for 200 ns;
       test_in <= "101";   wait for 200 ns;
       test_in <= "110";   wait for 200 ns;
       test_in <= "111";   wait for 200 ns;
   end process vect_test;
   
   -- Verificacin de las salidas
   verif : process
      variable error_status : boolean;
   begin
       wait on test_in;
       wait for 100 ns;
       if ( ( test_in = "000" and test_out = '1' ) or
            ( test_in = "001" and test_out = '0' ) or
            ( test_in = "010" and test_out = '0' ) or
            ( test_in = "011" and test_out = '1' ) or
            ( test_in = "100" and test_out = '0' ) or
            ( test_in = "101" and test_out = '1' ) or
            ( test_in = "110" and test_out = '1' ) or
            ( test_in = "111" and test_out = '0' ) )
       then
          error_status := false;
       else
          error_status := true;
       end if;
       assert not error_status
              report "Test fallado."
              severity note;
   end process verif;   
end architecture bp_arch;