-- Procedimiento para clculo de mnimo y mximo. 
-- fichero: minMax.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity minMax is
  generic ( limite : integer := 255 );
  port ( min_out, max_out : out integer range 0 to limite;
         ena              : in  std_logic;
         d1_in, d2_in     : in  integer range 0 to limite ); 
end entity minMax;

architecture minMax of minMax is

   procedure ordena ( 
        signal in1, in2 : in  integer range 0 to limite;
        signal min, max : out integer range 0 to limite ) is
   begin               
      if  (in1 > in2) then
         max <= in1;
         min <= in2;
      else    
         max <= in2;
         min <= in1;
      end if;        
   end procedure ordena;     

begin
   process (ena)
   begin
      if ( ena = '1' ) then
         ordena(d1_in, d2_in, min_out, max_out);
      end if;
   end process;
end architecture minMax;