-- XOR de los bits de una seal de 4 bits
-- Fichero: xor_1senal_4bits_bucleFor.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity xor_1seal_4bits is
   port ( y : out std_logic;
          a : in  std_logic_vector(3 downto 0) );
end entity xor_1seal_4bits;

architecture xor_1seal_4bits_bucleFor of xor_1seal_4bits is
    constant WIDTH : integer := 4;
    signal   tmp   : std_logic_vector( WIDTH-1 downto 0 );
begin
   process ( a , tmp )    
   begin 
       tmp(0) <= a(0);   
       for i in 1 to (WIDTH-1) loop
          tmp(i) <= a(i) xor tmp(i-1);
       end loop;
   end process;  
   y <= tmp(WIDTH-1);
end architecture xor_1seal_4bits_bucleFor;