-- Detector de paridad usando sentencia GENERATE condicional
-- fichero: detectorParidad_generate.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity paridad is
   port ( parity     : out  std_logic;
          parity_IN  : in   std_logic_vector(7 downto 0)); 
end entity paridad;

architecture paridad of paridad is
  signal temp: std_logic_vector(6 downto 0);
  component xor2 is 
    port ( y0     : out std_logic;
           x0, x1 : in  std_logic );
  end component xor2;
begin    

   parity <= temp(6);

   gen_array: for I in 0 to 6 generate

      inicial: if I = 0 generate
         xor_0: xor2 port map
                     (temp(I), parity_IN(0), parity_IN(I+1));
      end generate inicial;
     
      intermedio: if I /= 0 generate
         resto_xor: xor2 port map
                         (temp(I), temp(I-1), parity_IN(I+1));
      end generate intermedio; 
            
  end generate gen_array;

end architecture paridad;  
