library IEEE;
use IEEE.std_logic_1164.all;

entity retardo_bp is 
end entity retardo_bp;

architecture retardo_bp of retardo_bp is

   signal s1, s2, s3, s4  :  std_logic;
   signal in1, in2        :  std_logic;

   component nand2 is 
      port ( y0     : out std_logic;
             x0, x1 : in  std_logic );
   end component nand2; 

begin

    -- Crear el UUT para el test
    g0 : component nand2 port map (s1, in1, in2);

    s2 <= in1 nand in2 after 2 ns;  -- Misma forma de onda que s1

    process is
        variable var1, var2 : std_logic;
    begin
        for i in 0 to 4 loop  -- Itera 5 veces
           var1 := in1 nand in2;
           var2 := var1;      -- var2 debe ser igual a var1
           s3   <= in1 nand in2; 
           s4   <= s3;        -- s4 debe ser igual al valor
                              -- "antiguo" de s3
           wait for 10 ns;    -- Repetir para 0, 10, 20, 30 y 40 ns. 
        end loop;
        wait;    -- Detiene el proceso 
    end process;

    -- Crear los vectores de test
    in1 <= '1';
    in2 <= '0',                               -- in2 comienza a 0
           '1' after 10 ns, '0' after 11 ns,  -- Pulso de 1 ns 
                                              -- en el instante 10 ns
           '1' after 20 ns, '0' after 22 ns,  -- Pulso de 2 ns 
                                              -- en el instante 20 ns
           '1' after 26 ns, '0' after 29 ns;  -- Pulso en el 
                                              -- instante 26 ns

end architecture retardo_bp;