-- Banco de pruebas
-- fichero: bp_decodificador_3_a_8.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity bp_decodificador_3_a_8 is 
end entity bp_decodificador_3_a_8;

architecture bp_decodificador_3_a_8 of bp_decodificador_3_a_8 is

   signal Y : std_logic_vector( 7 downto 0);  -- Conectar salidas UUT
   signal E, A0, A1, A2  : std_logic;         -- Conectar entradas UUT

   component decodificador_3_a_8 is 
      port ( Y7, Y6, Y5, Y4, Y3, Y2, Y1, Y0 : out std_logic;  
             E, A0, A1, A2                  : in  std_logic);
   end component decodificador_3_a_8;

begin
   -- Instanciar y conectar UUT
   uut : component decodificador_3_a_8 port map
         ( Y(7), Y(6), Y(5), Y(4), Y(3), Y(2), Y(1), Y(0), 
           E, A0, A1, A2 );

   gen_vec_test : process
      variable test_in     : unsigned (3 downto 0); -- Vector de test
      variable esperado_Y  : std_logic_vector(7 downto 0);
      variable error_count : integer   := 0; 
   begin
      test_in := B"0000";
      report "Comienza la simulacin";    

      for count in 0 to 15 loop
         E <= test_in(3);
         A2 <= test_in(2);
         A1 <= test_in(1);
         A0 <= test_in(0);

         if    (count <  8) then esperado_Y := "00000000"; 
         elsif (count =  8) then esperado_Y := "00000001"; 
         elsif (count =  9) then esperado_Y := "00000010";
         elsif (count = 10) then esperado_Y := "00000100";
         elsif (count = 11) then esperado_Y := "00001000";
         elsif (count = 12) then esperado_Y := "00010000";
         elsif (count = 13) then esperado_Y := "00100000";
         elsif (count = 14) then esperado_Y := "01000000";
         else                    esperado_Y := "10000000";
         end if;
      
         wait for 10 ns;  
         test_in := test_in + 1;
         if ( esperado_Y /= Y ) then
            report "ERROR en la salida valida. Valor esperado: " & 
                   std_logic'image(esperado_Y(7))                &
                   std_logic'image(esperado_Y(6))                &
                   std_logic'image(esperado_Y(5))                &
                   std_logic'image(esperado_Y(4))                &
                   std_logic'image(esperado_Y(3))                &
                   std_logic'image(esperado_Y(2))                &
                   std_logic'image(esperado_Y(1))                &
                   std_logic'image(esperado_Y(0))                &                                                                                                      
                   ", valor actual: "                            & 
                   std_logic'image(Y(7))                         &
                   std_logic'image(Y(6))                         &
                   std_logic'image(Y(5))                         &
                   std_logic'image(Y(4))                         &
                   std_logic'image(Y(3))                         &
                   std_logic'image(Y(2))                         &
                   std_logic'image(Y(1))                         &
                   std_logic'image(Y(0))                         &                                                                                                                       
                   " en el instante: "                           &
                   time'image(now);
            error_count := error_count + 1;
         end if;
      
      end loop;
      report  "ERROR: Hay "              & 
              integer'image(error_count) & 
              " errores.";    
      wait;
   end process gen_vec_test;

end architecture bp_decodificador_3_a_8;
