-- Banco de pruebas del conversor de cdigo binario a Gray
-- fichero: bp_binary2Gray.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity bp_codGray is
   constant DELAY    : time    := 10 ns; -- Retardo usado en el test
end entity bp_codGray;

architecture bp_codGray of bp_codGray is

   signal x  : std_logic_vector(2 downto 0);   
   signal y  : std_logic_vector(2 downto 0);

   component codGray is
      port ( y : out std_logic_vector(2 downto 0);
             x : in  std_logic_vector(2 downto 0)  );
   end component codGray;

begin  

   UUT : component codGray port map
         (y, x);
    
   vec_test : process is
      variable temp  : unsigned (2 downto 0);
   begin
      report "Comienza la simulacin";

      -- Genera todos los posibles valores de entrada
      for i in 0 to 7 loop
         temp := TO_UNSIGNED(i,3);
         x(2) <= std_logic(temp(2));
         x(1) <= std_logic(temp(1));   
         x(0) <= std_logic(temp(0));        
         wait for DELAY;     
      end loop; 
    
      report "Simulacin finalizada";
      wait;   -- Final de la simulacin
   end process vec_test;

end architecture bp_codGray;
