-- Banco de pruebas del comparador F = X<5
-- fichero: bp_comparaXmenor5.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity bp_comparaXmenor5 is 
end entity bp_comparaXmenor5;

architecture bp_comparaXmenor5 of bp_comparaXmenor5 is

   signal F : std_logic;                    -- Conectar salidas UUT
   signal x : std_logic_vector(3 downto 0); -- Conectar entradas UUT
  
   component comparaXmenor5 is 
      port ( F : out std_logic;
             x : in  std_logic_vector(3 downto 0));
   end component comparaXmenor5;

begin

   -- Instanciar y conectar UUT
   uut : component comparaXmenor5 port map
         ( F => F, x => x );

   gen_vec_test : process
      variable test_in : unsigned (3 downto 0):= B"0000"; -- Vector 
                                                          -- de test
      variable num_errores : integer := 0; -- Numero de errores
   begin
      for count in 0 to 15 loop
         x(3)  <= test_in(3);
         x(2)  <= test_in(2);
         x(1)  <= test_in(1);
         x(0)  <= test_in(0);
         wait for 10 ns;  
         -- Comprueba resultado
         if ( F = '0' and test_in < 5 ) or 
            ( F = '1' and test_in >= 5 ) then     
            report( "Error. Valor " & 
                    integer'image(to_integer(test_in)) );
            num_errores := num_errores + 1;
         end if;     
         test_in := test_in + 1; 
      end loop;

      report "Test completo. Hay "      &
             integer'image(num_errores) & " errores.";
      wait;  -- Final simulacin
   end process gen_vec_test;

end architecture bp_comparaXmenor5;