-- Banco de pruebas del decodificador BCD a 7 segmentos
-- fichero: bp_bcdTo7Seg.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity bp_bcdTo7Seg is
   constant DELAY    : time := 10 ns; -- Retardo usado en el test
end entity bp_bcdTo7Seg;

architecture bp_bcdTo7Seg of bp_bcdTo7Seg is  
   signal segs : std_logic_vector(6 downto 0); 
   signal bcd  : std_logic_vector(3 downto 0);
     
   component bcdTo7Seg is
      port ( a, b, c, d, e, f, g : out  std_logic;
             i3, i2, i1, i0      : in   std_logic);       
   end component bcdTo7Seg;

begin  

   UUT : component bcdTo7Seg port map
        (segs(6), segs(5), segs(4), segs(3), segs(2), 
         segs(1), segs(0), bcd(3), bcd(2), bcd(1), bcd(0));
    
   vec_test : process is
      variable valor  : unsigned (3 downto 0);
   begin
      report "Comienza la simulacin";
      -- Generar todos los posibles valores de entrada
      for i in 0 to 9 loop
         valor := TO_UNSIGNED(i,4);
         bcd <= std_logic(valor(3)) & std_logic(valor(2)) &
                std_logic(valor(1)) & std_logic(valor(0));    
         wait for DELAY;     
      end loop; 
      report "Simulacin finalizada";
      wait;   -- Final de la simulacin
   end process vec_test;

end architecture bp_bcdTo7Seg;
