-- Decodificador BCD a 7 segmentos, usando sentencia if
-- fichero: bcdTo7SegIF.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity BCDto7seg is
   port( a, b, c, d, e, f, g : out std_logic;
         i3, i2, i1, i0      : in  std_logic );
end BCDto7seg;

architecture BCDto7segIF of BCDto7seg is
begin

   process(i3, i2, i1, i0)
      variable bcd  : std_logic_vector (3 downto 0);
      variable segs : std_logic_vector (6 downto 0);
   begin
      bcd := i3 & i2 & i1 & i0;
      if    (bcd = "0000") then segs := "1111110";
      elsif (bcd = "0001") then segs := "0110000";
      elsif (bcd = "0010") then segs := "1101101";
      elsif (bcd = "0011") then segs := "1111001";
      elsif (bcd = "0100") then segs := "0110011";
      elsif (bcd = "0101") then segs := "1011011";
      elsif (bcd = "0110") then segs := "1011111";
      elsif (bcd = "0111") then segs := "1110000";
      elsif (bcd = "1000") then segs := "1111111";
      elsif (bcd = "1001") then segs := "1110011";       
      else                      segs := "0000000";
      end if;
      a <= segs(6);
      b <= segs(5);
      c <= segs(4);
      d <= segs(3);
      e <= segs(2);
      f <= segs(1);
      g <= segs(0);
   end process;

end architecture BCDto7segIF;