-- Decodificador BCD a 7 segmentos, 
-- usando sentencia concurrente condicional
-- fichero: bcdTo7SegConc.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity BCDto7seg is
   port( a, b, c, d, e, f, g : out std_logic;
         i3, i2, i1, i0      : in std_logic  );
end BCDto7seg;

architecture BCDto7segConc of BCDto7seg is
   signal bcd  : std_logic_vector (3 downto 0);
   signal segs : std_logic_vector (6 downto 0);
begin
   bcd  <= i3 & i2 & i1 & i0;
   segs <=       "1111110" when (bcd = "0000")
            else "0110000" when (bcd = "0001")
            else "1101101" when (bcd = "0010")
            else "1111001" when (bcd = "0011")
            else "0110011" when (bcd = "0100")
            else "1011011" when (bcd = "0101")
            else "1011111" when (bcd = "0110")
            else "1110000" when (bcd = "0111")
            else "1111111" when (bcd = "1000")
            else "1110011" when (bcd = "1001")
            else "0000000";
   a <= segs(6);
   b <= segs(5);
   c <= segs(4);
   d <= segs(3);
   e <= segs(2);
   f <= segs(1);
   g <= segs(0);
end architecture BCDto7segConc;