-- Decodificador BCD a 7 segmentos, usando sentencia select
-- fichero: bcdTo7SegWithSelect.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity BCDto7seg is
   port( a, b, c, d, e, f, g : out std_logic;
         i3, i2, i1, i0      : in  std_logic  );
end BCDto7seg;

architecture BCDto7segWithSelect of BCDto7seg is
   signal bcd  : std_logic_vector (3 downto 0);
   signal segs : std_logic_vector (6 downto 0);
begin
   bcd  <= i3 & i2 & i1 & i0;
   with bcd select
      segs <=  "1111110" when "0000",
               "0110000" when "0001",
               "1101101" when "0010",
               "1111001" when "0011",
               "0110011" when "0100",
               "1011011" when "0101",
               "1011111" when "0110",
               "1110000" when "0111",
               "1111111" when "1000",
               "1110011" when "1001",
               "0000000" when others;
   a <= segs(6);
   b <= segs(5);
   c <= segs(4);
   d <= segs(3);
   e <= segs(2);
   f <= segs(1);
   g <= segs(0);
end architecture BCDto7segWithSelect;