-- Sumador de 2 nmeros de N bits
-- fichero: sumador_Nbits_generate.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity sumador_Nbits is 
   generic ( N : integer :=4 );
   port ( s     : out std_logic_vector(N-1 downto 0);
          C_out : out std_logic;
          x, y  : in  std_logic_vector(N-1 downto 0);
          C_in  : in  std_logic  );
end entity sumador_Nbits;

architecture sumador_Nbits of sumador_Nbits is

   signal carryv: std_logic_vector (N downto 0);
   
   component sum_completo is 
      port ( s, C_out   : out std_logic;
             x, y, C_in : in  std_logic  );
   end component sum_completo;

begin

   carryv(0) <= C_in;
    
   -- Instanciacin y conexin de componentes usando GENERATE
   conexion: for k in N-1 downto 0 generate  -- GENERATE iterativo
      FullAdder: sum_completo
                 port map (s(k), Carryv(k+1), x(k), y(k), Carryv(k));
   end generate conexion;
    
   C_out <= carryv(N);

end architecture sumador_Nbits;