-- Banco de pruebas comparador de igualdad de dos nmeros de N bits
-- fichero: bp_comparadorEQNbits.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity bp_comparadorEQNbits is 
end entity bp_comparadorEQNbits;

architecture bp_comparadorEQNbits of bp_comparadorEQNbits is
   signal s    : std_logic;                    -- Conectar salidas UUT
   signal x, y : std_logic_vector(3 downto 0); -- Conectar entradas UUT
  
   component comparadorEQNbits is 
      generic( N: integer :=4);
      port   ( s    : out std_logic;
               x, y : in std_logic_vector (N-1 downto 0) );
   end component comparadorEQNbits;

begin
   -- Instanciar y conectar UUT
   uut : component comparadorEQNbits port map
         ( s => s, x => x, y => y );

   gen_vec_test : process
      variable num_errores  : integer := 0;  -- Nmero de errores
   begin
      for op_X in 0 to 2**4-1 loop
         for op_Y in 0 to 2**4-1 loop
            x <= std_logic_vector ( to_unsigned(op_x,4) );
            y <= std_logic_vector ( to_unsigned(op_y,4) );
            wait for 10 ns;  
            -- Comprueba resultado
            if ( x = y and s = '0' ) or ( x /= y and s = '1' ) then     
               report "Error. Valores " & 
                      integer'image(op_x) &
                      ", " &
                      integer'image(op_y);
               num_errores := num_errores + 1;
            end if;     
         end loop;
      end loop;
      report "Test completo. Hay "      &
             integer'image(num_errores) & " errores.";
      wait; -- Final simulacin
   end process gen_vec_test;

end architecture bp_comparadorEQNbits;