-- Comparador igualdad de 2 nmeros de N bits
-- fichero: comparadorEQNbits.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity comparadorEQNbits is 
   generic ( N: integer :=4 );
   port ( s    : out std_logic;
          x, y : in std_logic_vector (N-1 downto 0) );
end entity comparadorEQNbits;

architecture comparadorEQNbits of comparadorEQNbits is
   signal p: std_logic_vector(N downto 0);
   component comparadorEQ1bit is 
      port ( p1       : out std_logic;
             p0, x, y : in  std_logic );
   end component comparadorEQ1bit;
begin
   p(0) <= '1';
   --Instanciacin y conexin de componentes usando GENERATE
   conexion: for k in N-1 downto 0 generate -- GENERATE iterativo
      comparadorNbits: comparadorEQ1bit
                       port map (p(k+1), p(k), x(k), y(k));
   end generate conexion;
   s <= p(N);
end architecture comparadorEQNbits;