-- MUX 4x1
-- fichero: mux_4x1_process_if_case.vhd
library IEEE; 
use IEEE.std_logic_1164.all;

entity mux_4x1 is 
   port ( d               : out std_logic;
          i3, i2, i1, i0  : in  std_logic;
          s1, s0          : in  std_logic );
end entity mux_4x1;

architecture mux_4x1 of mux_4x1 is
begin

   process (i3, i2, i1, i0, s1, s0) 
      variable sel : integer;
   begin

      if    (s1='0' and s0='0') then
          sel := 0;
      elsif (s1='0' and s0='1') then
          sel := 1;
      elsif (s1='1' and s0='0') then
          sel := 2;
      else
          sel := 3;
      end if;

      case sel is
          when 0      =>
              d <= i0;
          when 1      =>
              d <= i1;
          when 2      =>
              d <= i2;
          when others =>
              d <= i3;
      end case;

   end process;

end architecture mux_4x1;