-- Sumador completo de 1 bit
-- fichero: sumadorCompleto1bitEstruc.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use work.puertasLogicas_package.all;

entity sum_completo is 
   port ( s, C_out   : out std_logic;
          x, y, C_in : in  std_logic);
end entity sum_completo;

architecture sum_completo_estruc of sum_completo is
   signal n1, n2, n3, n4: std_logic;
begin
   -- Instanciacin y conexin de los componentes
   XOR2_1 : component xor2 port map 
           (x0 => x,    x1 => y,              y0 => n1    );
   XOR2_2 : component xor2 port map 
           (x0 => C_in, x1 => n1,             y0 => s     );
   AND2_1 : component and2 port map 
           (x0 => x,    x1 => y,              y0 => n2    );
   AND2_2 : component and2 port map 
           (x0 => x,    x1 => C_in,           y0 => n3    );
   AND2_3 : component and2 port map 
           (x0 => y,    x1 => C_in,           y0 => n4    );
   OR3_1  : component or3  port map 
           (x0 => n2,   x1 => n3,   x2 => n4, y0 => C_out );
end architecture sum_completo_estruc;