-- ALU, bloque process
-- fichero: ALU_bloqueProcess.vhd
library IEEE; 
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.ALU_CONSTANTS.all;
 
architecture ALU_bloqueProcess of ALU is
begin
   process (A, B, mode) is
   begin
      case mode is 
         when "000"  => C <= std_logic_vector(signed(A)+signed(A));
         when "001"  => C <= std_logic_vector(signed(A)+signed(B));
         when "010"  => C <= std_logic_vector(signed(A)-signed(B));
         when "011"  => C <= std_logic_vector(-signed(A));
         when "100"  => C <= A and B;
         when "101"  => C <= A or  B;
         when "110"  => C <= A xor B;
         when others => C <= not A;
      end case;
   end process;
end architecture ALU_bloqueProcess;