-- ALU, sentencia concurrente
-- fichero: ALU_concurrente.vhd
library IEEE; 
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.ALU_CONSTANTS.all;

entity ALU is 
   port (  C    : out  std_logic_vector (WIDTH-1    downto 0);
           A, B : in   std_logic_vector (WIDTH-1    downto 0);
           mode : in   std_logic_vector (SEL_BITS-1 downto 0) );
end entity ALU;

architecture ALU_concurrente of ALU is
begin
   C <=   std_logic_vector (signed(A)+signed(A)) when (mode="000")
     else std_logic_vector (signed(A)+signed(B)) when (mode="001")
     else std_logic_vector (signed(A)-signed(B)) when (mode="010")
     else std_logic_vector (-signed(A)         ) when (mode="011")
     else A and B                                when (mode="100")
     else A or  B                                when (mode="101")
     else A xor B                                when (mode="110")
     else not A;    
end architecture ALU_concurrente;