-- Banco de pruebas del registro de 4 bits
-- fichero: bp_regDesp4Bits.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity bp_regDesp is 
end entity bp_regDesp;

architecture bp_regDesp of bp_regDesp is
   constant PERIODO  : time      := 200 ns;  -- Reloj
   signal Serial_out : std_logic;            -- Salidas UUT
   signal clk        : std_logic := '0';     -- Entradas UUT
   signal Serial_in  : std_logic;
        
   component regDesp is
      port ( Serial_out : out std_logic;
             clk        : in std_logic;
             Serial_in  : in std_logic);
   end component regDesp;
begin
   -- Instanciar y conectar UUT
   uut : component regDesp port map (Serial_out, clk, Serial_in);
                  
   clk <= not clk after (PERIODO/2);             
                  
   gen_vec_test : process is
   begin
      report "Comienza la simulacin";
      Serial_in<='0'; wait until falling_edge(clk); -- 200 ns
      Serial_in<='1'; wait until falling_edge(clk); -- 400 ns
      Serial_in<='1'; wait until falling_edge(clk); -- 600 ns
      Serial_in<='0'; wait until falling_edge(clk); -- 800 ns
      report "Finaliza la simulacin";
      wait;     -- Final del bloque process
   end process gen_vec_test;

end architecture bp_regDesp;