-- Registro desplazamiento de N bits
-- fichero: regDespNbits.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity regDesp is

   generic ( N: integer := 4 );

   port ( Serial_out     : out std_logic;
          Serial_in, clk : in  std_logic  );

end entity regDesp;

architecture regDesp of regDesp is
begin

   process (clk)
      variable R: std_logic_vector(N-2 downto 0);   
   begin
      if (rising_edge(clk)) then
         Serial_out <= R(N-2);        
         for index in N-3 downto 0 loop 
            R(index+1) := R(index);
         end loop;
         R(0) := Serial_in;
      end if;
   end process;

end architecture regDesp;