-- Registro serie-a-paralelo y paralelo-a-series, de 4 bits
-- fichero: registroSerieParalelo.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity registroSerieParalelo is 
   port( Serial_out : out std_logic;
         Q          : out std_logic_vector(3 downto 0);
         Clock      : in  std_logic;
         SHSel      : in  std_logic_vector(1 downto 0);
         Serial_in  : in  std_logic;
         D          : in  std_logic_vector(3 downto 0)  );
end entity registroSerieParalelo;

architecture registroSerieParalelo of registroSerieParalelo is
   signal content: std_logic_vector(3 downto 0);
begin

   process(Clock)
   begin
      if( rising_edge(Clock) ) then
         case SHSel is
            when "01" =>       -- Carga paralelo
               content <= D;
            when "10" =>       -- Desplazamiento drcha 
                               -- y rellena a la izqda con bits 
                               -- entrada Serial_in
               content <= Serial_in & content(3 downto 1);
            when others =>
               null;
            end case;
        end if;
    end process;
    
    Q <= content;
    Serial_out <= content(0); -- Bit ms a la drcha 

end architecture registroSerieParalelo;