-- ALU con registro
-- fichero: aluReg.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.ALUReg_CONSTANTS.all;

entity ALUReg is
   port( Z    : out std_logic_vector ( WIDTH-1    downto 0 );
         A, B : in  std_logic_vector ( WIDTH-1    downto 0 );
         Sel  : in  std_logic_vector ( SEL_BITS-1 downto 0 );
         clk  : in  std_logic  );
end ALUReg;

architecture ALUReg of ALUReg is
   signal alu_salida : std_logic_vector ( WIDTH-1 downto 0 );
begin

   -- ALU  
   alu: process (Sel, A, B)
   begin
      case Sel (SEL_BITS-1 downto 1) is
         when "00" =>
            alu_salida <= std_logic_vector(signed(A) + signed(B));
         when "01" => 
            alu_salida <= std_logic_vector(signed(A) - signed(B));
         when "10" =>
            alu_salida <= A and B;
         when others => 
            alu_salida <= A or B;
      end case;
  end process alu;

  -- Registro 
  reg:process(clk)
  begin
     if rising_edge(clk) then
        if (Sel(0) = '1') then  -- Desplaza a la drcha introduciendo 0
           Z <= '0' & alu_salida(WIDTH-1 downto 1);
              else              -- Carga el nuevo valor
           Z <= alu_salida;    
        end if;
     end if;
  end process reg;

end architecture ALUReg;