-- Memoria de slo lectura (ROM) 8x8
-- fichero: ROM.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity rom is

   generic ( bits  : integer := 8;     -- Nm. bits por palabra
             words : integer := 8  );  -- Nm. palabras en mem.

   port ( data : out std_logic_vector(bits-1 downto 0);
          addr : in  integer range 0 to words-1  );

end rom;

architecture rom of rom is

   type vector_array is array (0 to words-1) of
      std_logic_vector(bits-1 downto 0);
        
   constant memory: vector_array := ( "00000000",
                                      "00000010",
                                      "00000100",
                                      "00001000",
                                      "00010000",
                                      "00100000",
                                      "01000000",
                                      "10000000"  );
begin
   data <= memory(addr);
end architecture rom;