-- Banco de pruebas de la ROM 8*8
-- fichero: bp_ROM.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity bp_ROM is
   constant DELAY    : time    := 10 ns; -- Retardo usado en el test
end entity bp_ROM;

architecture bp_ROM of bp_ROM is  

   signal addr : integer range 0 to 7;
   signal data : std_logic_vector(7 downto 0);
     
   component rom is
      generic ( bits  : integer := 8;    -- Num. bits por palabra
                words : integer := 8  ); -- Num. palabras en mem.
      port ( data : out std_logic_vector(7 downto 0);
             addr : in  integer range 0 to 7);     
   end component rom;

begin  

   UUT : component rom port map 
         (data, addr);
    
   vec_test : process is
   begin
      report "Comienza la simulacin";

      -- Generar todos los posibles valores de entrada
      for i in 0 to 7 loop
         addr <= i;    
         wait for DELAY;     
      end loop; 
    
      report "Simulacin finalizada";
      wait;   -- Final de la simulacin
   end process vec_test;

end architecture bp_ROM;