-- Memoria de acceso aleatorio (RAM) 16x8
-- fichero: RAM.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity ram is

   generic( bits  : integer := 8;    -- Nm. bits por palabra
            words : integer := 16 ); -- Nm. palabras en mem.

   port( data_out : out std_logic_vector (bits-1 downto 0);
         wr_ena   : in  std_logic;
         clk      : in  std_logic;
         addr     : in  integer range 0 to words-1;
         data_in  : in  std_logic_vector (bits-1 downto 0) );

end entity ram;

architecture ram of ram is

   type vector_array is array (0 to words-1) of
      std_logic_vector (bits-1 downto 0);
        
   signal memory: vector_array;

begin

   process(clk, wr_ena)
   begin
      if ( wr_ena = '1' ) then
         if rising_edge(clk) then
            memory(addr) <= data_in;
         end if;
      end if;
   end process;

   data_out <= memory(addr);

end architecture ram;
