library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity bp_detector is
   constant PERIODO   : time      := 20 ns;           -- Periodo clk
end entity bp_detector;

architecture bp_detector of bp_detector is
   signal Y           : std_logic;                    -- Salida UUT
   signal Patron      : std_logic_vector(7 downto 0); -- Salida UUT
   signal DataPIN     : std_logic_vector(7 downto 0); -- Entradas UUT
   signal DataSIN     : std_logic; 
   signal Clk         : std_logic := '0';
   signal Reset, Load : std_logic;

   component detector is
      port (  Y       : out std_logic;
              Patron  : out std_logic_vector(7 downto 0);
              Clk     : in  std_logic;
              Reset   : in  std_logic;
              Load    : in  std_logic;
              DataSIN : in  std_logic;
              DataPIN : in  std_logic_vector(7 downto 0) );
   end component detector;

begin  
   UUT : component detector port map
        (Y, Patron, Clk, Reset, Load, DataSIN, DataPIN);
   Clk   <= not Clk after (PERIODO/2);
   reset <= '1', '0' after 15 ns;

   vec_test : process is
      variable temp  : std_logic_vector (7 downto 0);
   begin
      report "Comienza la simulacin"; 
      load    <= '1';
      DataPIN <= "11111100";
      DataSIN <= '0';    
      wait for 2*PERIODO;
      temp    := DataPIN;
      load    <= '0';
      for i in 7 downto 0 loop
         DataSIN <= temp(i);
         wait for PERIODO;       
         if i>0 then
            assert(Y='0') report("Valor de Y erroneo");
         else 
            assert(Y='1') report("Valor de Y erroneo");
         end if;
      end loop;
      wait;  -- Termina la simulacin
   end process vec_test;
end architecture bp_detector;

