library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity detector is 
   port( Y       : out std_logic;
         Patron  : out std_logic_vector(7 downto 0);
         Clk     : in  std_logic;
         Reset   : in  std_logic;
         Load    : in  std_logic;
         DataSIN : in  std_logic;
         DataPIN : in  std_logic_vector(7 downto 0) );
end entity detector;

architecture detector of detector is
   signal PatronLOC : std_logic_vector(7 downto 0);
   signal RegCONT   : std_logic_vector(7 downto 0);
begin
   Reg: process (Clk)
   begin
      if rising_edge(Clk) then 
         if (Reset = '1') then
            RegCONT <= (others =>'0');
         else
            RegCONT <= RegCONT(6 downto 0)&DataSIN;
         end if;
      end if;
   end process;

   LoadP: process (Clk)
   begin
      if rising_edge(Clk) then
         if (Load = '1') then
            PatronLOC <= DataPIN;
         end if;
      end if;
   end process;

   Patron <= PatronLOC;
   
   comp: process (RegCONT, PatronLOC)
   begin
      Y <= '0';
      if (RegCONT = PatronLOC) then 
         Y<= '1';
      end if;
   end process;
end architecture detector;