-- Banco de pruebas del registro de 4 bits
-- fichero: bp_Reg4.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity bp_Reg4 is 
end entity bp_Reg4;

architecture bp_Reg4 of bp_Reg4 is
   constant PERIODO : time       := 10 ns;       -- Reloj
   signal   Q    : std_logic_vector(3 downto 0); -- Salidas UUT
   signal   clk  : std_logic  := '0';            -- Entradas UUT
   signal   I    : std_logic_vector(3 downto 0);
   signal   rst  : std_logic;           
  
   component Reg4 is
      port ( Q        : out std_logic_vector(3 downto 0);
             I        : in  std_logic_vector(3 downto 0);
             clk, rst : in  std_logic  );
   end component Reg4;
begin
   -- Instanciar y conectar UUT
   uut : component Reg4 port map (Q, I, clk, rst);
                  
   clk <= not clk after (PERIODO/2);             
                  
   gen_vec_test : process is
   begin
      report "Comienza la simulacin";
    
      I   <= "1111";    -- Reset
      rst <= '1';
      wait until rising_edge(clk);
      wait for (PERIODO/2);
    
      I   <= "1111";    -- Carga 1111
      rst <= '0';
      wait until rising_edge(clk);
      wait for (PERIODO/2);

      I   <= "1010";    -- Carga 1010
      rst <= '0';
      wait until rising_edge(clk);
      wait for (PERIODO/2);

      I   <= "0000";    -- Carga 0000
      rst <= '0';
      wait until rising_edge(clk);
      wait for (PERIODO/2);

      report "Finaliza la simulacin";
      wait;     -- Final del bloque process
   end process gen_vec_test;
end architecture bp_Reg4;