-- Registro multifuncin de 4 bits 
-- fichero: Reg4mf.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity Reg4mf is
   port ( Q              : out std_logic_vector(3 downto 0);
          I              : in  std_logic_vector(3 downto 0);
          Shr_In, Shl_In : in  std_logic;
          Ld, Shr, Shl   : in  std_logic;
          clk, rst       : in  std_logic  );
end entity Reg4mf;    
    
architecture Reg4mf of Reg4mf is    
   signal R : std_logic_vector(3 downto 0);
begin
   Q <= R;

   process (clk)
   begin
      if rising_edge(clk) then
         if (rst = '1') then
            R <= "0000";
         elsif (Ld = '1') then
            R <= I;
         elsif (Shr = '1') then
            R(3) <= Shr_In;
            for index in 0 to 2 loop
               R(index) <= R(index+1);
            end loop;
         elsif (Shl = '1') then
            R(0) <= Shl_In;
            for index in 0 to 2 loop
               R(index+1) <= R(index);
            end loop;         
         end if;    
      end if;
   end process;    
end architecture Reg4mf;