-- Registro de desplazamiento de 32 bits
-- fichero: RegDesp32.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity RegDesp32 is
   port ( Q           : out std_logic_vector(31 downto 0);
          Shr, Shr_in : in  std_logic;
          clk, rst    : in  std_logic  );
end entity RegDesp32;    
    
architecture RegDesp32 of RegDesp32 is    
   signal R : std_logic_vector(31 downto 0);
begin
   process (clk)
   begin
      if rising_edge(clk) then
         if (rst = '1') then
            R <= X"00000000";
         elsif (Shr = '1') then
            R(31) <= Shr_in;
            for index in 0 to 30 loop
               R(index) <= R(index+1);
            end loop;
         end if;    
      end if;
   end process;  
   Q <= R;  
end architecture RegDesp32;