-- Banco de pruebas del registro de 32 bits
-- fichero: bp_RegDesp32.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity bp_RegDesp32 is 
end entity bp_RegDesp32;

architecture bp_RegDesp32 of bp_RegDesp32 is

   constant PERIODO        : time       := 10 ns;   

   signal   Q      : std_logic_vector(31 downto 0);  
   signal   clk    : std_logic  := '0';              
   signal   Shr    : std_logic;
   signal   Shr_in : std_logic;
   signal   rst    : std_logic;           
  
   component RegDesp32 is
      port ( Q           : out std_logic_vector(31 downto 0);
             Shr, Shr_in : in  std_logic;
             clk, rst    : in  std_logic  );
   end component RegDesp32;

begin
   -- Instanciar y conectar UUT
   uut : component RegDesp32 port map 
         (Q, Shr, Shr_in, clk, rst);
                  
   clk <= not clk after (PERIODO/2);             
                  
   gen_vec_test : process is
   begin
      report "Comienza la simulacin";
    
      -- Reset
      rst <= '1';        
      Shr <= '1'; Shr_in <= '1';
      wait until rising_edge(clk);
      wait for (PERIODO/2);
    
      -- Carga serie 16 bits '1'
      rst <= '0';        
      Shr <= '1'; Shr_in <= '1';
      for index in 0 to 15 loop
         wait until rising_edge(clk);
      end loop;
      wait for (PERIODO/2);
      assert ( Q = X"FFFF0000" )
         report "Fallado Q=FFFF0000";

      -- Carga serie 16 bits '0'
      rst <= '0';        
      Shr <= '1'; Shr_in <= '0';
      for index in 0 to 15 loop
         wait until rising_edge(clk);
      end loop;
      wait for (PERIODO/2);
      assert ( Q = X"0000FFFF" )
         report "Fallado Q=0000FFFF";

      Shr <= '0'; 
      report "Finaliza la simulacin";
      wait;     -- Final del bloque process
   end process gen_vec_test;

end architecture bp_RegDesp32;