-- Banco de pruebas del registro de 32 bits con acceso a fichero
-- fichero: bp_RegDesp32fich.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use std.textio.all;

entity bp_RegDesp32 is 
end entity bp_RegDesp32;

architecture bp_RegDesp32fich of bp_RegDesp32 is

   constant PERIODO        : time       := 10 ns;   

   signal   Q      : std_logic_vector(31 downto 0);  
   signal   clk    : std_logic  := '0';              
   signal   Shr    : std_logic;
   signal   Shr_in : std_logic;
   signal   rst    : std_logic; 

   component RegDesp32 is
      port ( Q           : out std_logic_vector(31 downto 0);
             Shr, Shr_in : in  std_logic;
             clk, rst    : in  std_logic  );
   end component RegDesp32;

begin

   uut : component RegDesp32 port map 
         (Q, Shr, Shr_in, clk, rst);

   clk <= not clk after (PERIODO/2);             
                  
   gen_vec_test : process is
      file     fichVectores : text;
      variable inputLinea   : line;
      variable inputBit     : bit;
   begin
      report "Comienza la simulacin";

      -- Reset
      rst <= '1'; Shr <= '1'; Shr_in <= '1';
      wait until rising_edge(clk);
      wait for (PERIODO/2);
    
      -- Carga de vectores de test desde fichero
      rst <= '0'; 
      file_open(fichVectores, "vectores.txt", read_mode);
      while not endfile(fichVectores) loop
         readline(fichVectores, inputLinea);
         for i in inputLinea'range loop
            read(inputLinea, inputBit);
            if inputBit = '1' then
               Shr_in <= '1';
            else
               Shr_in <= '0';
            end if;
            wait until rising_edge(clk);
         end loop; -- bucle for
      end loop;    -- bucle while
      file_close(fichVectores);

      Shr <= '0'; 
      wait until rising_edge(clk);
      report "Finaliza la simulacin";
      wait;     -- Final del bloque process
   end process gen_vec_test;

end architecture bp_RegDesp32fich;