-- Registro de 32 bits con output enable
-- fichero: Reg32_OE.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity Reg32_OE is
   port ( Q         : out std_logic_vector(31 downto 0);
          I         : in  std_logic_vector(31 downto 0);
          Ld, OE    : in  std_logic;
          clk, rst  : in  std_logic  );
end entity Reg32_OE;    
    
architecture Reg32_OE of Reg32_OE is    
   signal R : std_logic_vector(31 downto 0);
begin

   regProc: process (clk)
   begin
      if rising_edge(clk) then
         if (rst = '1') then
            R <= (others => '0');
         elsif (Ld = '1') then
            R <= I;
         end if;    
      end if;
   end process regProc;  
   
   outputProc: process (R, OE)
   begin
      if (OE='1') then
         Q <= R;
      else
         Q <= (others => 'Z');
      end if; 
   end process outputProc;

end architecture Reg32_OE;