-- Register file 4x32. Descripcin estructural
-- fichero: RegFile4x32_estruc.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity RegFile4x32 is
   port ( R_data         : out std_logic_vector(31 downto 0);
          W_data         : in  std_logic_vector(31 downto 0);
          R_addr, W_addr : in  std_logic_vector(1 downto 0);  
          R_en, W_en     : in  std_logic;
          clk, rst       : in  std_logic  ); 
end entity RegFile4x32;

architecture RegFile4x32_estruc of RegFile4x32 is

   component Dcd2x4 is
     port ( d3, d2, d1, d0 : out  std_logic;
            i1, i0         : in   std_logic;
            en             : in   std_logic  ); 
   end component Dcd2x4;
   
   component Reg32_OE is
     port ( Q         : out std_logic_vector(31 downto 0);
            I         : in  std_logic_vector(31 downto 0);
            Ld, OE    : in  std_logic;
            clk, rst  : in  std_logic  );
   end component Reg32_OE;

   signal W_d3, W_d2, W_d1, W_d0 : std_logic;
   signal R_d3, R_d2, R_d1, R_d0 : std_logic;
   
begin

   R_Dcd : Dcd2x4   port map 
           (R_d3, R_d2, R_d1, R_d0, R_addr(1), R_addr(0), R_en);
   W_Dcd : Dcd2x4   port map 
           (W_d3, W_d2, W_d1, W_d0, W_addr(1), W_addr(0), W_en);
   Reg0  : Reg32_OE port map 
           (R_data, W_data, W_d0, R_d0, clk, rst );
   Reg1  : Reg32_OE port map 
           (R_data, W_data, W_d1, R_d1, clk, rst );
   Reg2  : Reg32_OE port map 
           (R_data, W_data, W_d2, R_d2, clk, rst );
   Reg3  : Reg32_OE port map  
           (R_data, W_data, W_d3, R_d3, clk, rst );

end architecture RegFile4x32_estruc;