-- Fuente de datos unidireccional (lectura)
-- fichero: fuenteUnidireccional.vhd
library IEEE; 
use IEEE.std_logic_1164.all;

entity fuenteUnidireccional is 
   generic ( WORD_SIZE  : integer := 8;      -- Bits por palabra, 
                                             -- por defecto 8
             READ_DELAY : time    := 10 ns); -- Retardo en lectura, 
                                             -- por defecto 10 ns 
   port ( data : out std_logic_vector(WORD_SIZE-1 downto 0);  
                                             -- Datos de salida
          OE_n : in  std_logic);             -- Habilita lectura
end entity fuenteUnidireccional;

architecture fuenteUnidireccional of fuenteUnidireccional is
begin
   rom : process (OE_n)
   begin
      if (OE_n = '0') then
         data <= ( 0 => '1', others => '0' ) after READ_DELAY;
      else 
         data <= (others => 'Z');            
      end if;
   end process rom;
end architecture fuenteUnidireccional;