-- Detector de 3 o ms unos consecutivos
-- fichero: detector.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity detector is 
   port( Y     : out std_logic;
         state : out std_logic_vector(1 downto 0);
         X     : in  std_logic;
         reset : in  std_logic;
         clk   : in  std_logic );
end entity detector;

architecture detector of detector is
   signal internal_state: std_logic_vector(1 downto 0);
begin 
   state <= internal_state;
 
   -- Clculo salida
   salida: process (internal_state) is
   begin
      case internal_state is
         when "00"   =>   Y <= '0';
	      when "01"   =>   Y <= '0';
	      when "10"   =>   Y <= '0';
         when others =>   Y <= '1';
      end case;
   end process salida;
 
   -- Clculo del prximo estado
   proximo_estado: process (clk, reset)
   begin
      if (reset = '1') then     -- Reset asncrono
         internal_state <= "00";
      elsif (rising_edge(clk)) then
         case internal_state is
            when "00" =>        -- Estado actual: S0
               if X = '1' then
                  internal_state <= "01";
               else
                  internal_state <= "00";
               end if;
            when "01" =>        -- Estado actual: S1
               if X = '1' then 
                  internal_state <= "10";
               else 
                  internal_state <= "00";
               end if;
            when "10" =>        -- Estado actual: S2
               if X = '1' then
                  internal_state <= "11";
               else 
                  internal_state <= "00";
               end if;
            when "11" =>        -- Estado actual: S3
               if X = '1' then
                  internal_state <= "11";
               else 
                  internal_state <= "00";
               end if;
            when others=>       -- Por completitud
               internal_state <= "00";
            end case;
      end if;
   end process proximo_estado;
   
end architecture detector; 
