-- Contador BCD implementado como mquina de Moore
-- fichero: contadorBCD.vhd
library IEEE;
use IEEE.std_logic_1164.all;
 
entity contador is 	
   port( count      : out std_logic_vector(3 downto 0);
         clk, reset : in  std_logic );
end entity contador;

architecture contador of contador is
   signal internal_state: std_logic_vector(3 downto 0);
begin
   count <= internal_state;
 
   -- Clculo del prximo estado
   proximo_estado: process (clk, reset)
   begin
      if (reset = '1') then
         internal_state <= "0000";
      elsif (rising_edge(clk)) then
         case internal_state is
            when "0000" => 
               internal_state <= "0001";
            when "0001" =>
               internal_state <= "0010";
            when "0010" =>
               internal_state <= "0011";
            when "0011" =>
               internal_state <= "0100";                 
            when "0100" => 
               internal_state <= "0101";
            when "0101" =>
               internal_state <= "0110";
            when "0110" =>
               internal_state <= "0111";
            when "0111" =>
               internal_state <= "1000";                
            when "1000" =>
               internal_state <= "1001";
            when "1001"=>
               internal_state <= "0000";
            when others =>
               internal_state <= "0000";
         end case;
      end if;
   end process proximo_estado;
   
end architecture contador; 