-- Contador binario ascendente y descendente de 4 bits
-- fichero: udcounter.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity udcounter is 
   port ( Q:     out std_logic_vector(3 downto 0);
          Clock: in  std_logic;
          Clear: in  std_logic;
          Count: in  std_logic;
          Down:  in  std_logic );
end udcounter;

architecture udcounter of udcounter is
begin

   process (Clock, Clear)
      variable value: integer range 0 to 15;
   begin
      if ( Clear = '1' ) then
         value := 0;
      elsif ( rising_edge(Clock) ) then
         if ( Count = '1' ) then
            if ( Down = '0' ) then
               value := value + 1;
            else
               value := value - 1;
            end if;
         end if;
      end if;
      Q <= std_logic_vector(to_unsigned(value,4));
   end process;

end udcounter;
