-- Flip flop RS
-- fichero: flipflopRS.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity flipflopRS is
   port( q, notq            : out std_logic;
         clk, R, S, reset_n : in  std_logic  );
end entity flipflopRS;

architecture flipflopRS of flipflopRS is
   signal q_interna : std_logic;
begin
   q    <= q_interna;
   notq <= not  q_interna;
   
   process (reset_n, clk)
      variable aux : std_logic;
   begin
      if (reset_n = '0') then
     	   aux := '0';
      elsif (rising_edge(clk)) then
         if (R='1' and S='0') then 
            aux := '0';
         elsif (R='0' and S='1') then
            aux := '1';
         end if;
      end if;
      q_interna <= aux;
   end process;

end architecture flipflopRS;