-- Contador mdulo 4 implementado como mquina de Moore
-- fichero: contador_Mod_4.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use work.STATE_CONSTANTS.all;

entity contador_Mod_4 is 
   port ( state : out std_logic_vector(STATE_BITS-1 downto 0);
          clock, reset, c : in  std_logic  );
end entity contador_Mod_4;

architecture contador_Mod_4 of contador_Mod_4 is

   signal internal_state: std_logic_vector(STATE_BITS-1 downto 0);

begin 

   state <= internal_state;

   -- Clculo del prximo estado
   proximo_estado: process (clock, reset)
   begin
      if (reset = '1') then
         internal_state <= S0;
      elsif (rising_edge(clock)) then
         case internal_state is
            when S0 => 
               if c = '1' then
                  internal_state <= S1;
               end if;
            when S1 =>
               if c = '1' then 
                  internal_state <= S2;
               end if;
            when S2 =>
               if c = '1' then
                  internal_state <= S3;
               end if;
            when S3 =>
               if c = '1' then
                  internal_state <= S0;
               end if;
            when others=>
               internal_state <= S0;
         end case;
      end if;
   end process proximo_estado;

end architecture contador_Mod_4; 