-- Contador mdulo 4 implementado como mquina de Moore
-- fichero: contador_Mod_4_estruct.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use work.STATE_CONSTANTS.all;

entity contador_Mod_4 is 
   port( state           : out std_logic_vector(STATE_BITS-1 downto 0);
         clock, reset, c : in  std_logic  );
end entity contador_Mod_4;

architecture contador_Mod_4 of contador_Mod_4 is
   signal Q1_n, Q0_n, Q1, Q0                     : std_logic;
   signal reset_n, c_n                           : std_logic;
   signal yand_1, yand_2, yand_3, yand_4, yand_5 : std_logic;
   signal yor_1, yor_2                           : std_logic;
  
  component flipflop_D is 
     port ( q               : out std_logic;
            d, clk, reset_n : in  std_logic );
  end component flipflop_D;
  
  component and3 is 
     port ( y0         : out std_logic;
            x0, x1, x2 : in  std_logic );
  end component and3;
  
  component or3 is 
     port ( y0         : out std_logic;
            x0, x1, x2 : in  std_logic );
  end component or3;
  
  component and2 is 
     port ( y0     : out std_logic;
            x0, x1 : in  std_logic );
  end component and2;
  
  component or2 is 
     port ( y0     : out std_logic;
            x0, x1 : in  std_logic );
  end component or2;
  
  component not1 is 
     port ( y0 : out std_logic;
            x0 : in  std_logic );
  end component not1;

begin 
   state(1) <= Q1;
   state(0) <= Q0;
   not_1 : not1       port map (Q1_n, Q1);
   not_2 : not1       port map (Q0_n, Q0);
   not_3 : not1       port map (reset_n, reset);
   not_4 : not1       port map (c_n, c);
   and_1 : and2       port map (yand_1, c_n, Q1);
   and_2 : and2       port map (yand_2, Q1, Q0_n);
   and_3 : and3       port map (yand_3, c, Q1_n, Q0);
   or_1  : or3        port map (yor_1, yand_1, yand_2, yand_3);
   and_4 : and2       port map (yand_4, c_n, Q0);
   and_5 : and2       port map (yand_5, c, Q0_n);
   or_2  : or2        port map (yor_2, yand_4, yand_5);
   D1    : flipflop_D port map (Q1, yor_1, clock, reset_n);
   D2    : flipflop_D port map (Q0, yor_2, clock, reset_n);
end architecture contador_Mod_4; 