-- Generador de onda implementado como mquina de estados
-- fichero: generadorOnda.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use work.STATE_CONST.all;

entity generador is 
   port( wave : out std_logic;
         clk  : in std_logic  );
end entity generador;

architecture fsm of generador is
   signal state : std_logic_vector(STATE_BITS-1 downto 0);
begin 
   proximo_estado: process (clk) 
   begin
      if (rising_edge(clk)) then
         case state is
            when S0 =>      state <= S1; wave <= '0'; 
            when S1 =>      state <= S2; wave <= '1';
            when S2 =>      state <= S3; wave <= '0';
            when S3 =>      state <= S4; wave <= '1';
            when S4 =>      state <= S5; wave <= '1';
            when S5 =>      state <= S6; wave <= '1'; 
            when S6 =>      state <= S7; wave <= '0';
            when others =>  state <= S0; wave <= '0'; 
         end case;
      end if;
   end process proximo_estado; 
end architecture fsm;