-- Banco de pruebas del divisor de frecuencia por 3
-- fichero: bp_divisor_frecuencia_3.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity bp_divisor_frecuencia_3 is 
end entity bp_divisor_frecuencia_3;

architecture bp_divisor_frecuencia_3 of bp_divisor_frecuencia_3 is
   constant PERIODO       : time       := 100 ns; -- Reloj
   signal   clk           : std_logic  := '0';    -- Entradas UUT
   signal   clk3, resetn  : std_logic;           
  
   component divisor_frecuencia_3 is 
      port( clk3        : out std_logic;
            clk, resetn : in  std_logic );
   end component divisor_frecuencia_3; 
 
begin
   -- Instanciar y conectar UUT
   uut : component divisor_frecuencia_3 port map
         (clk3, clk, resetn);
                  
   resetn <= '1', 
             '0' after (PERIODO/4),
             '1' after (PERIODO + PERIODO/4);

   clk <= not clk after (PERIODO/2);                           
 
end architecture bp_divisor_frecuencia_3;
