-- Circuito generador de seales
-- fichero: gen.vhd
library IEEE; 
use IEEE.std_logic_1164.all;

entity gen is 
   port( out1, out2, out3 : out std_logic;
         clk              : in std_logic  );
end entity gen;

architecture gen of gen is

   type state is (one, two, three);

   signal internal_state1      : state;
   signal internal_state2      : state;
   signal temp_out1, temp_out2 : std_logic;

begin
   -- Mquina de estados 1
   proximo_estado1 : process(clk)
   begin
      if (rising_edge(clk)) then
         case internal_state1 is
            when one   =>
               internal_state1 <= two;
            when two   =>
               internal_state1 <= three;
            when three =>
               internal_state1 <= one;
         end case;
      end if;
   end process proximo_estado1;

   salida1 : process (internal_state1)
   begin
      case internal_state1 is
         when one   =>
            temp_out1 <= '1';
         when two   =>
            temp_out1 <= '0';
         when three =>
            temp_out1 <= '1';
      end case;
   end process salida1;

   -- Mquina de estados 2
   proximo_estado2 : process (clk)
   begin
      if (falling_edge(clk)) then
         case internal_state2 is
            when one   =>
               internal_state2 <= two;
            when two   =>
               internal_state2 <= three;
            when three =>
               internal_state2 <= one;
         end case;
      end if;
   end process proximo_estado2;

   salida2 : process (internal_state2)
   begin
      case internal_state2 is
         when one   =>
            temp_out2 <= '1';
         when two   =>
            temp_out2 <= '1';
         when three =>
            temp_out2 <= '0';
      end case;
   end process salida2;

   out1 <= temp_out1;
   out2 <= temp_out2;
   out3 <= temp_out1 and temp_out2;
end gen;  