-- Biestable JK con reset asncrono en nivel LOW
-- fichero: flipflop_JK.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity flipflop_JK is
   port ( q, q_n              : out std_logic;
          clk, J, K, reset_n  : in  std_logic );
end entity flipflop_JK;

architecture flipflop_JK of flipflop_JK is
   signal q_interna : std_logic;
begin
   q   <= q_interna;
   q_n <= not q_interna;
   process (reset_n, clk) is
      variable JK : std_logic_vector (1 downto 0);
   begin
      if (reset_n = '0') then
         q_interna <= '0';
      elsif rising_edge(clk) then
         JK := J & K;
         case (JK) is
            when "01"   =>   q_interna <= '0';
            when "10"   =>   q_interna <= '1';
            when "11"   =>   q_interna <= not q_interna;
            when others =>   null;
         end case;    
      end if;
   end process;    
end architecture flipflop_JK;    