-- Diseo estructural de la mquina de Moore
-- fichero: maquinaMooreSimple_estruc.vhd
library IEEE;
use IEEE.std_logic_1164.all;

architecture maquinaMooreSimple_estruc of maquinaMooreSimple is
   signal  A,  B : std_logic;  -- Variables de estado actuales
   signal NA, NB : std_logic;  -- Prximas variables de estado
  
   component flipflop_D is 
      port ( q, q_n          : out std_logic;
             d, clk, reset_n : in  std_logic );
   end component flipflop_D;
begin
   state <= A & B; -- Muestra estado actual en el puerto de salida
   -- Conexiones de los flip-flops
   -- Las salidas q_n se dejan sin conectar
   dff_A: component flipflop_D port map
          ( q => A, d => NA, clk => clk, reset_n => reset_n );
   dff_B: component flipflop_D port map
          ( q => B, d => NB, clk => clk, reset_n => reset_n );
   -- Funciones para el clculo del nuevo estado y la salida
   NA <= ( (not x) and (not A) ) or (x and A);
   NB <= x and (not A);
   z  <= A;
end architecture maquinaMooreSimple_estruc;