-- Banco de pruebas no exhaustivo
-- fichero: bp1_seq0110.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.seq0110_CONST.all;

entity bp1_seq0110 is
   constant PERIODO : time := 100 ns; -- Periodo reloj
end entity bp1_seq0110;  

architecture bp1_seq0110 of bp1_seq0110 is
   signal z_long  : std_logic;         -- Salida de la mquina
   signal state   : std_logic_vector(STATE_BITS-1 downto 0); 
                                       -- Estado actual
   signal reset_n : std_logic;         -- Reset sncrono activado LOW   
   signal clk     : std_logic := '0';  -- Seal de reloj 
   signal x       : std_logic;         -- Entrada a la mquina
    
   component seq0110 is
      port ( z_long  : out  std_logic;
             state   : out  std_logic_vector(STATE_BITS-1 downto 0); 
             reset_n : in   std_logic;         
             clk     : in   std_logic;         
             x       : in   std_logic );                                    
   end component seq0110;
begin
   UUT: component seq0110 port map          -- Instanciar UUT
        ( z_long, state, reset_n, clk, x );
   -- Generar un pulso LOW en la entrada de reset         
   reset_n <= '1', 
              '0' after ( PERIODO/4 ),
              '1' after ( PERIODO + PERIODO/4 );
   -- Seal de reloj, asumiendo que ha sido inicializada a '0'
   clk <= not clk after ( PERIODO/2 );
   -- Generar algunos vectores de test
   main : process is
   begin
      report "Comienza la simulacin";
      x <= '0';    wait for 2*PERIODO;   
      x <= '1';    wait for PERIODO;   
      x <= '1';    wait for PERIODO;   
      x <= '0';    wait for PERIODO;   
      x <= '1';    wait for PERIODO;   
      x <= '1';    wait for PERIODO;   
      x <= '0';    wait for PERIODO;   
      x <= '1';    wait for PERIODO;   
      wait;  -- Detiene este bloque process, pero no finaliza la
             -- simulacin dado que hay asignaciones concurrentes
   end process main;   
end architecture bp1_seq0110; 