architecture maquinaMooreSimple of maquinaMooreSimple is
   signal internal_state: std_logic_vector(STATE_BITS-1 downto 0);
begin
   state <= internal_state; -- Muestra el estado
   
   -- Genera la salida
   salida: process(internal_state) is
   begin
      case internal_state is
         when S0     =>   z <= '0';
         when S1     =>   z <= '0';
         when S2     =>   z <= '1';
         when others =>   z <= '0';  -- Salida en el estado ilegal
      end case;
   end process salida;
   
   -- Genera el siguiente estado
   proximo_estado: process(reset_n, clk) is
   begin
      if (reset_n = '0') then      -- Reset asncrono
         internal_state <= S0;
      elsif rising_edge(clk) then  -- En flanco subida del reloj
         case internal_state is
            when S0 =>             -- Estado actual: S0
               if (x = '1') then
                  internal_state <= S1;
               else
                  internal_state <= S2;
               end if;
            when S1 =>             -- Estado actual: S1
               if (x = '0') then
                  internal_state <= S2;
               end if;
            when S2 =>             -- Estado actual: S2 
               if (x = '0') then
                  internal_state <= S0;
               end if;
            when others =>         -- Del estado ilegal va a S0
               internal_state <= "00"; 
         end case;
      end if;   
   end process proximo_estado;
   
end architecture maquinaMooreSimple;