-- Banco de pruebas del circuito que calcula el mximo comn divisor
-- fichero: bp_gcd.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity bp_gcd is 
end entity bp_gcd;

architecture bp_gcd of bp_gcd is
   constant PERIODO  : time       := 100 ns;          -- Reloj

   signal result     : std_logic_vector (3 downto 0); -- Salidas UUT
   signal opA, opB   : std_logic_vector (3 downto 0);
   signal clk        : std_logic  := '0';             -- Entradas UUT
   signal reset, fin : std_logic;           

   component gcd is 
      port ( result     : out std_logic_vector(3 downto 0);
             fin        : out std_logic;
             opA, opB   : in  std_logic_vector(3 downto 0);
             reset,clk  : in  std_logic );
   end component gcd;

begin
   uut : component gcd port map
         (result, fin, opA, opB, reset, clk);
                  
   clk <= not clk after (PERIODO/2);   

   process	
   begin
      -- Caso 1: la salida debera ser 0100
      reset <= '1';  opA <= "1100";  opB <= "1000";
      wait for PERIODO/3; 
      reset <= '0';
      wait for 4*PERIODO;
      -- Caso 2: la salida debera ser 0010
      reset <= '1';  opA <= "1100";  opB <= "0010";
      wait for PERIODO/3; 
      reset <= '0';
      wait for 7*PERIODO;
      wait;   --Final bloque process
   end process;

end architecture bp_gcd;
