-- Circuito que calcula el mximo comn divisor de dos nmeros
-- fichero: gcd.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity gcd is 
   port ( result    :  out std_logic_vector(3 downto 0);
          fin       :  out std_logic;
          opA, opB  :  in  std_logic_vector(3 downto 0);
          reset,clk :  in  std_logic );
end entity gcd;

architecture gcd of gcd is
   signal state : integer;  -- Contador que indica el paso 
   signal A, B  : std_logic_vector(3 downto 0);
begin

   process ( reset, clk ) is
   begin
      if ( reset = '1' ) then
         state <= 1;          -- Inicializa state 
         A     <= opA;
         B     <= opB;
         fin   <= '0';
      elsif rising_edge( clk ) then
         state <= state + 1; -- Incrementa state 
         case ( state ) is   -- state codifica los pasos del algoritmo
            when 1 =>
               if (B = A) then
                  result <= B;
                  fin    <= '1';
                  state  <= 2;
               elsif (B > A) then
                  B     <= std_logic_vector ( signed(B) - signed(A) );
                  state <= 1;
               else 
                  A     <= std_logic_vector ( signed(A) - signed(B) );
                  state <= 1;
               end if; 
            when others =>
               state <= 2; -- Espera a que la seal reset sea 1
         end case;
      end if;     -- de rising_edge( clk )
   end process;    
    
end architecture gcd;