-- Banco de pruebas del circuito calculador de la media
-- fichero: bp_media.vhd
library IEEE;
use IEEE.std_logic_1164.all;

entity bp_media is 
end entity bp_media;

architecture bp_media of bp_media is
   constant PERIODO  : time       := 100 ns;          -- Reloj

   signal result     : std_logic_vector (3 downto 0); -- Salidas UUT
   signal A, B, C, D : std_logic_vector (3 downto 0);
   signal clk        : std_logic  := '0';             -- Entradas UUT
   signal reset, fin : std_logic;           

   component media is 
      port ( result      : out std_logic_vector(3 downto 0);
             fin         : out std_logic;
             A, B, C, D  : in  std_logic_vector(3 downto 0);
             reset,clk   : in  std_logic  );
   end component media;

begin
   uut : component media port map
         (result, fin, A, B, C, D, reset, clk);
                  
   clk <= not clk after (PERIODO/2);   

   process	
   begin
      -- Caso 1: la salida debera ser 0001
      reset <= '1';  
      A <= "0001";  B <= "0001";  C <= "0001";  D <= "0001";
      wait for PERIODO/3; 
      reset <= '0';
      wait for 6*PERIODO;
      -- Caso 2: la salida debera ser 0010
      reset <= '1'; 
      A <= "0010";  B <= "0010";  C <= "0010";  D <= "0010";
      wait for PERIODO/3; 
      reset <= '0';
      wait for 7*PERIODO;
      wait;    -- Final del bloque process
   end process;

end architecture bp_media;
