-- Calcula la media aritmtica de 4 nmeros de 4 bits
-- fichero: media.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity media is 
   port ( result      : out std_logic_vector(3 downto 0);
          fin         : out std_logic;
          A, B, C, D  : in  std_logic_vector(3 downto 0);
          reset,clk   : in  std_logic );
end entity media;

architecture media of media is
   signal state : integer;   -- Contador que indica el paso 
   type vector_array is array(0 to 3) of std_logic_vector(3 downto 0);
   signal R     : vector_array;
   signal i     : integer range 0 to 3;
   signal Sum   : std_logic_vector(3 downto 0);
begin
        
   process ( reset, clk ) is
   begin
      if ( reset = '1' ) then
         state <= 1;         -- Inicializa state 
         Sum  <= "0000";
         R(0) <= A;  R(1) <= B;  R(2) <= C;  R(3) <= D;
         fin  <= '0';
      elsif rising_edge( clk ) then
         case ( state ) is  -- state codifica los pasos del algoritmo
            when 1 =>
               i     <= 0; 
               state <= 2; 
            when 2 =>           
               Sum <= std_logic_vector(unsigned(Sum) + unsigned(R(i)));
               if (i >= 3 ) then
                  state <= 3;
               else
                  state <= 2;
                  i     <= i + 1; 
               end if;
            when 3 =>
               fin    <= '1'; 
               state  <= 4;
               result <= std_logic_vector( unsigned(Sum)/4 ); 
            when others =>
               state <= 4;    -- Espera a que la seal reset sea 1
         end case;
      end if;     
   end process;    
    
end architecture media;