-- Circuito conversor de BCD a binario
-- fichero: bcd_to_bin.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.BCD_CONST.all;

entity bcd_to_bin is
   port( bin: out std_logic_vector(LENGTH-1 downto 0);
         bcd: in  std_logic_vector(LENGTH-1 downto 0) );    
end entity bcd_to_bin;

architecture bcd_to_bin of bcd_to_bin is
begin

   process (bcd) is   -- Bloque sensible a cambios en la entrada
      variable bcd_concat_bin : unsigned(2*LENGTH-1 downto 0);
      variable temp           : unsigned(3 downto 0);
   begin
      bcd_concat_bin := unsigned(bcd) & TO_UNSIGNED(0,LENGTH);
      for i in 0 to LENGTH-1 loop                         -- Paso 2
         bcd_concat_bin := shift_right(bcd_concat_bin,1); -- Paso 2a
         for j in 0 to (LENGTH/4)-1 loop                  -- Paso 2b
            temp := bcd_concat_bin(LENGTH+j*4+3 downto LENGTH+j*4);
            if (temp(3) = '1') then    -- Si la secuencia de 4 bits
               temp := temp - "0011";  -- es mayor que 7, se resta 3
            end if;
            bcd_concat_bin(LENGTH+j*4+3 downto LENGTH+j*4) := temp;
         end loop; -- end for Paso 2b
      end loop;    -- end for Paso 2
      bin <= std_logic_vector( bcd_concat_bin(LENGTH-1 downto 0) );
   end process;

end architecture bcd_to_bin;