package DEFS is
   constant FUNCION_1 : integer := z;    
             -- z es un nmero de estado que define unvocamente 
             -- esta funcin. Debe satisfacerse: z > m + x + 1
   ...
end package DEFS;
   
architecture ...
   signal state : integer;  -- Contador que indica el paso del  
                            -- seudocodigo que est ejecutndose
   ...
   seudocodigo : process ( reset_n, clk ) is
   begin
      if ( reset_n = '0' ) then
         ...   -- Operaciones de inicializacin (Paso 0 seudocdigo)
         state <= 1;  -- Inicializa state 
      elsif rising_edge( clk ) then
         state <= state + 1;   -- Incrementa state 
         case ( state ) is  -- state codifica los pasos del algoritmo
            when 1 =>
               ...          -- Operaciones del Paso 1 del seudocodigo
            when 2 =>
               ...          -- Operaciones del Paso 2 del seudocodigo
            ...
            when k =>
               i <= 0;      -- Inicializacin del bucle for
            when k + 1 =>
               ...          -- Primer paso dentro del bucle for
            when k + 2 =>
               ...          -- Segundo paso dentro del bucle for
            ...
            when k + x =>
               ...          -- ltimo paso dentro del bucle for
               if (i < max) then
                  state <= k + 1;
               end if;
               i <= i + 1;   
            ...
            when m + x =>   -- Se supone que FUNCION_1 es llamada aqu
               ret_state <= m + x + 1;  -- Return state
               state <= FUNCION_1;      -- Va a la FUNCION_1
            when m + x + 1 =>
               ...
            ...
            when FUNCION_1 =>
               -- Operaciones del Paso 1 de la funcin FUNCION_1
            when FUNCION_1 + 1 =>
               -- Operaciones del Paso 2 de la funcin FUNCION_1
            ...
            when FUNCION_1 + y =>     -- ltimo paso de FUNCION_1
               state <= ret_state;    -- return al procedimiento 
                                      -- que hace la llamada
            ...
            when others =>  -- Paso n del seudocdigo
               state <= 0;
         end case;
      end if;   -- de rising_edge( clk )
   end process seudocodigo;
end architecture ...;
