-- Circuito detector de secuencia 0111 1110
-- fichero: detector_sec.vhd
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity detector_sec is
   port ( detectado : out std_logic;
          reset_n   : in  std_logic;
          clk       : in  std_logic;
          data_in   : in  std_logic );
end entity detector_sec;


architecture detector_sec1 of detector_sec is
begin
   process (reset_n, clk) is
      variable prev_data : unsigned (7 downto 0);
   begin
      if (reset_n = '0') then
         prev_data := B"1111_1111";
      elsif rising_edge(clk) then
         prev_data    := prev_data sll 1; 
         prev_data(0) := data_in;
         if (prev_data = B"0111_1110") then
            detectado <= '1';
         else 
            detectado <= '0';
         end if;
      end if;
   end process;
end architecture detector_sec1;


architecture detector_sec2 of detector_sec is
   signal prev_data : unsigned (7 downto 0);
begin
   process (reset_n, clk) is        
   begin
      if (reset_n = '0') then
         prev_data <= B"1111_1111";
      elsif rising_edge(clk) then
         prev_data <= (prev_data(6 downto 0) & data_in);
         if ((prev_data(6 downto 0) & data_in) = B"0111_1110") then
            detectado <= '1';
         else 
            detectado <= '0';
         end if;
      end if;
   end process;
end architecture detector_sec2;